% TeX format file for Plain TeXnicard.
% This file is licensed under the same terms as TeXnicard itself.

% As a special exception, if you create a document which uses this file,
% and link it with this file, this file does not by itself cause the
% resulting document to be covered by the GNU General Public License.
% This exception does not however invalidate any other reasons why the
% document might be covered by the GNU General Public License. If you
% modify this file, you may extend this exception to your version of the
% file, but you are not obligated to do so. If you do not wish to do so,
% delete this exception statement from your version.

%0
% \def\z#1{\.{\\#1}}
% This is the {\TeX} format file for Plain \TeX nicard. It is meant to be
% compiled into a format file and used with the \.{plain.cards} file.

% The template for the game should then define any additional codes on top
% of this one to make things specific for the game card style, such as
% where the text goes, what fonts to use, font colors, special symbols,
% etc.
%1

% --- Category codes ---

%0
% A few category codes are the same as Plain \TeX, but they are simplified
% here, since not as many are needed. Also note that the underscore is now
% considered a letter, so it can be used in names of macros.
%1

\catcode`\{=1
\catcode`\}=2
\catcode`\&=4
\catcode`\#=6
\catcode`\^=7
\catcode"09=10
\catcode`\_=11
\endlinechar=32

% --- Version ---

%0
% Here is the version information to identify this format. (The output
% \.{cards.tex} file will complain if you try to use a different format.)
% (Yes, computers can complain, too. But don't anthropomorhize computers,
% they don't like that.)

% {\bf N.B.:} The category codes must be defined first! (Otherwise you
% will not have access to \.\{ and \.\} for begin/end of a group)
%1

\def\fmtname{texnicard} \def\fmtversion{0.1}

% --- Escaped characters ---

%0
% Since some character are special use, it will be defined here as
% character escape codes that expand to the normal character. This can be
% used with commands such as \.{\\special} and \.{\\write}.
%1

\def\makecharescape#1{{
  \uccode`*=`#1\uppercase{\gdef#1{*}}
}}

\makecharescape\ %
\makecharescape\#
\makecharescape\$
\makecharescape\%
\makecharescape\&
\makecharescape\\
\makecharescape\{
\makecharescape\}
\makecharescape\^
\let\asciicircum=\^

% --- Count registers ---

\countdef\pageno=0
\countdef\resolution=1
\countdef\px_card_width=2
\countdef\px_card_height=3
\countdef\countA=10
\countdef\countB=11
\countdef\fontshrink=12
\countdef\maxfontshrink=13
\countdef\countC=14
\countdef\totallines=15
\countdef\parbreaklines=16
\countdef\layer_selected=17
\countdef\fontscale=18

\pageno=0
\fontshrink=0
\maxfontshrink=20
\parbreaklines=0

% --- Dimension registers ---

\dimendef\maxdimen=10
\dimendef\dimenA=11
\dimendef\dimenB=12
\dimendef\card_width=13
\dimendef\card_height=14
\dimendef\dimenC=15
\dimendef\lineskiplimit_change=16

\maxdimen=16383.99999pt

% --- Skip registers ---

\skipdef\smallskipamount=10
\skipdef\medskipamount=11
\skipdef\bigskipamount=12
\skipdef\skipA=13
\skipdef\skipB=14
\skipdef\skipC=15
\skipdef\parskip_change=16
\skipdef\baselineskip_change=17
\skipdef\lineskip_change=18

\smallskipamount=3pt plus 1pt minus 1pt
\medskipamount=6pt plus 2pt minus 2pt
\bigskipamount=12pt plus 4pt minus 4pt

% --- Token registers ---

\toksdef\backgroundcolor=10
\toksdef\toksA=11
\toksdef\toksB=12
\toksdef\toksC=13
\toksdef\fontcs=14

\backgroundcolor={none}

% --- Tracing parameters ---

%0
% These parameters are used to set tracing so that you will get output
% of \z{showbox} and things like that to standard output, with the full
% information of the box included. This can then be read back in later.
%1

\errorcontextlines=5
\showboxbreadth=20000
\showboxdepth=20000
\tracinglostchars=1
\tracingonline=1

% --- Programming macros ---

\let\outer=\Undefined
\let\nexp=\noexpand
\let\exp=\expandafter
\let\(=\csname
\let\)=\endcsname
\def\space{ }
\def\empty{}
\def\gobble#1{}
\let\bgroup={
\let\egroup=}
\def\nullbox{\hbox{}}
{\catcode`\$=3 \global\let\mathshift=$}

%0
% Now we are getting loopy! (Just like Plain \TeX; nothing special.)
%1

\def\loop#1\repeat{\def\loopbody{#1}\iterate}
\def\iterate{
  \loopbody\let\loopnext=\iterate\else\let\loopnext=\relax\fi\loopnext
}
\let\repeat=\fi % make \loop...\if...\repeat skippable

%0
% Here is a macro to reset the error count to zero.
%1

\def\reset_error_count{{\setbox0=\vbox{\noindent\vrule\par}}}

%0
% These macros will calculate the strech component and shrink component
% of a glue value.

% Note that the lowercase codes are temporarily changed so that when the
% skip register is expanded by \.{\\the}, that the category codes will be
% correct.

% (Also, the rule that kerns do not cause unexpected things to happen, is
% used, which is described later on.)
%1

\begingroup
\lccode`+=`p
\lccode`9=`l
\lccode`8=`u
\lccode`7=`s
\lccode`*=`m
\lccode`]=`i
\lccode`[=`n
\lowercase{

\gdef\read_ss#1+987#2*][87#3end#4!{%
  \skipB=#2\relax\skipC=#3\relax%
}%

% \ss_of{glue}{stretch_dimen_register}{shrink_dimen_register}
\gdef\ss_of#1#2#3{{%
  \skipA=#1\relax%
  \exp\read_ss\the\skipA end +987 0pt *][87 0pt end!%
  \kern\skipB\kern\skipC%
}#3=\lastkern\unkern#2=\lastkern\unkern}%

}\endgroup

%0
% This macro sets all codes 0 to 255 in a table (such as \z{catcode}).
% It is generally used inside of a group.
%1

% \set_all_codes{table}{value}
\def\set_all_codes#1#2{%
  \countA=0
  \loop\ifnum\countA<256
    #1\countA=#2\relax
  \advance\countA by 1 \repeat
}%

%0
% Since negative numbers are not allowed in \TeX nicard, we must fake it.
% Here is how it is faked.
%1

\def\enumber#1{%
  \ifnum#1<0
    0 \exp\gobble\number#1 -
  \else
    \number#1
  \fi
}%

%0
% In order to count tokens (such as how many digits fit in a symbol).
%1

\def\count_tokens#1=#2{%
  \begingroup
    \countA=0
    \def\xxx##1{%
      \ifx\relax##1%
        \let\xxx\empty
      \else
        \advance\countA by 1
      \fi
      \xxx
    }%
    \xxx#2\relax
    \kern\countA sp%
  \endgroup #1=\lastkern \unkern
}%

% --- Dealing with derived formats ---

%0
% Here, a macro is defined that will allow this file to act differently
% when a different format file is being loaded which is based on this one.
% Hyphenation patterns will not be loaded, and it won't dump at the end.
% That way, the file it is included from can hyphenate/dump.

% This is a strange tricky code. It attempts to load the main input file
% for the job (please note the name of this file might be changed in case
% it is a modified version, so the filename is not hardcoded). If it is
% this file, the first command will be \.{\\catcode}; otherwise, the first
% command will be something like \.{\\input texnicard\_format}. It is done
% inside of a group, so that the changed definitions and changed internal
% parameters are restored after the group.

% The percentage sign is normally a comment character. While it is doing
% these strange things, however, it is treated as the end of line
% character, which causes it to insert a space and skip the rest of the
% line. Actual spaces are ignored. Now, the macro \.{\\input} and
% \.{\\catcode} will read the entire line as its parameter. After it
% determines which file it is, it will skip the rest of the file, and
% therefore will then finish the group. The definitions of \.{\\dump} and
% \.{\\ifbaseformat} are global, so they will be the only thing persisting
% from all this mess.

% If it is a derived (inclusion) format, the first \.{\\dump} at the end
% of this file doesn't work, but it will cause the next one to work. Now
% the other file will have these definitions and can continue with some
% modifications before finally dumping the format.
%1

\let\real_dump=\dump

\begingroup
  \def \0{
    \endlinechar=`\%
    \catcode`\%=5
    \catcode32=9
    \let \1=\input
    \uppercase{
      \long\def \input##1 {
        \gdef \dump{\global\let \dump=\real_dump}
        \global\let\ifbaseformat=\iffalse
        \endinput
      }
      \long\def \catcode##1 {
        \global\let\ifbaseformat=\iftrue
        \endinput
      }
    }
    \1\jobname\relax
  }\0
\endgroup

% --- Reading \TeX's output back in ---

%0
% Here is a way of reading \TeX's output of things such as: errors,
% \z{show}, \z{showbox}, \z{tracingparagraphs}, and so on. You should run
% {\TeX} with a command such as: \.{tex cards > cards.fot}

% Input file 15 is used to read its own output. However, nothing can be
% read until a \z{message} has occured, and a \z{message} does not add a
% termination to the output line. One way to deal with this problem is to
% use \z{write} and \z{message} together.
%1

\def\fot_open{\openin15=\jobname.fot\fot_skip}

%0
% Using \z{write} and \z{message} together solves another problem too,
% which is to make it to skip everything that you don't want. This macro
% skips up to the current point in the online output log.
%1

\def\fot_skip{{%
  \immediate\write16{\^\%}\message{}%
  \set_all_codes\catcode{14}\catcode`\^=12%
  \let \1=\iftrue \loop
    \read1 to \0%
    \ifx\0\^\let \1=\iffalse\fi
  \1\repeat
}}%

%0
% However, these kind of things are probably not needed. They are provided
% anyways, in case it might be necessary sometimes.
%1

% --- Typesetting parameters ---

\adjdemerits=10000
\baselineskip=0pt
\brokenpenalty=100
\clubpenalty=10000
\doublehyphendemerits=10000
\emergencystretch=\maxdimen
\exhyphenpenalty=55
\finalhyphendemerits=5000
\hbadness=1000
\hfuzz=.1pt
\hoffset=0pt
\hsize=\maxdimen
\hyphenpenalty=60
\lefthyphenmin=2
\linepenalty=10
\lineskip=0pt
\lineskiplimit=0pt
\looseness=0
\overfullrule=0pt
\pagegoal=\maxdimen
\parfillskip=0pt plus .999fil
\parindent=0pt
\parskip=3pt plus 1pt minus .5pt
\pretolerance=100
\righthyphenmin=3
\splittopskip=0pt
\tolerance=500
\topskip=0pt
\vbadness=1000
\vfuzz=.1pt
\voffset=0pt
\vsize=\maxdimen

% --- Typesetting macros ---

\def\smallskip{\vskip\smallskipamount}
\def\medskip{\vskip\medskipamount}
\def\bigskip{\vskip\bigskipamount}
\def\noskip{\relax\ifvmode\prevdepth=-1000pt \fi}
\def\endpage{\par\vfil\penalty-20000 }
\def\br{\ifhmode\skip\parfillskip\penalty-10000 \else\noindent\fi}
\def\nobr{\penalty 10000 }

\def\thin{\hskip .16667em\relax}
\def\en{\hskip .5em\relax}
\def\em{\hskip 1em\relax}
\def\double_em{\hskip 2em\relax}

%0
% French and non-French spacing is like Plain \TeX, but in \TeX nicard
% the default is French instead of non-French.
%1

\def\frenchspacing{
  \sfcode`\.=1000 \sfcode`\?=1000 \sfcode`\!=1000
  \sfcode`\:=1000 \sfcode`\;=1000 \sfcode`\,=1000
}
\def\nonfrenchspacing{
  \sfcode`\.=3000 \sfcode`\?=3000 \sfcode`\!=3000
  \sfcode`\:=2000 \sfcode`\;=1500 \sfcode`\,=1250
}
\frenchspacing

%0
% And so, a control sequence \z{ep} to represent end of a paragraph. Here
% it is used to keep track of total lines, but it can be changed to do
% other things too.
%1

\def\ep{%
  \par\advance\totallines by\prevgraf
  \advance\totallines by\parbreaklines
}

%0
% This macro digs the box by removing extra glue and penalty and kerns
% at the end, so that the box behind it will be accessible.
%1

\def\digthis{%
  \unskip \unskip \unkern \unkern \unpenalty \unpenalty
  \unskip \unskip \unkern \unkern \unpenalty \unpenalty
  \unskip \unskip \unkern \unkern \unpenalty \unpenalty
}%

%0
% Now, here is a macro to calculate the overfullness of paragraphs in
% a vbox, and stores the result in a dimen register.

% It works by unpacking the given vbox into a sequence of hboxes which
% represent the lines of the text in the paragraph(s). And then it will
% repack the boxes to their natural width and check which ones are
% larger when naturally. (It won't work in case of rules and whatsits.
% This can be overcome by placing them in their own boxes.)

% Everything is computed inside of a group. Now, the final result must
% be brought to the outside of the group. This can be done using
% \.{\\global}, but what if you do not want it global? So, instead we
% can add a kern and then take it out after the group, so that it will
% be moved up by one group only. (This is perfectly safe; see sections
% 1000 and 1061 in {\sl\TeX: The Program}.) (The other thing is that
% it might be a register used by this macro; using kerns in this way
% avoids that problem, too.)
%1

% \overfullness{dimen-register}{box-register}
\def\overfullness#1#2{{\setbox4=\vbox{%
  \setbox0=\copy#2
  \dimenA=0pt
  \unvcopy0
  \loop
    \digthis
    \setbox2=\lastbox
    \ifvoid2 \countA=0 \else \countA=1 \fi
  \ifnum\countA=1
    \ifhbox2
      \dimenB=\wd2
      \setbox3=\hbox{\unhbox2}
      \dimenC=\wd3
      \advance\dimenC by-\dimenB
      \ifdim\dimenC>\dimenA \dimenA=\dimenC \fi
    \fi
  \repeat
  \kern\dimenA}\kern\ht4
}#1\lastkern\unkern}

%0
% It will be useful to turn off paragraph skip and so on. It should always
% be done after defining fonts, at least.
%1

\def\offlineskip{%
  \baselineskip=-1000pt\lineskip=0pt\lineskiplimit=\maxdimen\parskip=0pt%
  \parshape=0\parindent=0pt\leftskip=0pt\rightskip=0pt%
  \relax
}

% --- Fonts ---

%0
% The first thing is magnifications steps. No explanation is needed; this
% is the same as Plain \TeX.
%1

\def\magstephalf{1095 }
\def\magstep#1{\ifcase#1 1000\or1200\or1440\or1728\or2074\or2488\fi\relax}

%0
% The second thing is fonts that will scale to fit. The largest size text
% can fit in the box, if it doesn't fit then it will try the smaller size,
% until it fits, or if it is too small and you cannot make smaller text.

% The current values of \z{parskip}, \z{baselineskip}, \z{lineskip}, and
% \z{lineskiplimit} are stored with the font definition. The current
% values of registers \z{parskip\_change} and so on are used as amounts
% that the other parameters are changed by for each smaller size of the
% font.
%1

% \makescaledfonts{name}{file}{max_scale}{num_sizes}{change_amount}
\def\makescaledfonts#1#2#3#4#5{
  \countA=0
  \countB=#3
  \exp\xdef \(\string#1:count\){#4}
  \exp\xdef \(\string#1:registers\){%
    \reg_to_mac\parskip  \reg_to_mac\parskip_change
    \reg_to_mac\baselineskip  \reg_to_mac\baselineskip_change
    \reg_to_mac\lineskip  \reg_to_mac\lineskip_change
    \reg_to_mac\lineskiplimit  \reg_to_mac\lineskiplimit_change
  \relax}
  \loop \ifnum\countA<#4
    \global\exp\font \(\string#1:\the\countA\)=#2 scaled \countB
    \global\exp\font \(\string#1:#4\)=#2 scaled \countB
    \advance\countA by 1
    \advance\countB by #5
  \repeat
  \gdef#1{%
    \fontcs={#1}%
    \fontscale=#5
    \multiply\fontscale by \fontshrink
    \advance\fontscale by #3
    \ifnum\fontshrink>#4
      \(\string#1:#4\)%
    \else
      \(\string#1:\the\fontshrink\)%
    \fi
    \do_font_registers#1
  }
}

%0
% These are helper macros used by the above, so that line heights and so
% on can be affected by the amount of font shrinking.
%1

\def\reg_to_mac#1{#1=\the#1}
\def\reg_fontshrink#1#2{%
  \multiply#2by\fontshrink
  \advance#1by#2\relax
}
\def\do_font_registers#1{%
  \(\string#1:registers\)%
  \reg_fontshrink\parskip\parskip_change
  \reg_fontshrink\baselineskip\baselineskip_change
  \reg_fontshrink\lineskip\lineskip_change
  \reg_fontshrink\lineskiplimit\lineskiplimit_change
}

% --- Hyphenation ---

%0
% The standard hyphenation patterns from Plain {\TeX} are used here, they
% should be sufficient. Hyphenation can still be turned off, and you can
% still make exceptions. (Sorry, if you are making a different language,
% you will have to recompile the format. Too bad!)
%1

\ifbaseformat
  \input hyphen
\fi

% --- Card layout ---

\def\zhbox{\hbox to 0pt}
\def\zvbox{\vbox to 0pt}
\def\zvtop{\vtop to 0pt}

\def\h_left#1{\zhbox{#1\hss}}
\def\h_center#1{\zhbox{\hss#1\hss}}
\def\h_right#1{\zhbox{\hss#1}}
\def\v_top#1{\zvbox{#1\par\vss}}
\def\v_middle#1{\zvbox{\vss#1\par\vss}}
\def\v_bottom#1{\zvbox{\vss#1}}

%0
% There are two kind of positioning. You can position the top left corner
% of a box, or you can position the baseline of a box.
%1

% \position{x}{y}{contents}
\def\position#1#2#3{\vbox{\kern#2\relax\hbox{\kern#1\relax#3}\vss}}

% \positionbase{x}{y}{contents}
\def\positionbase#1#2#3{\hbox{\kern#1\lower#2 #3\hss}}

\def\hidehrule#1#2{\kern-#1\hrule height#1 depth#2\kern-#2\relax}
\def\hidevrule#1#2{%
  \kern-#1{\dimen0=#1\advance\dimen0 by #2\vrule width\dimen0}\kern-#2
}

%0
% You can make a border with this.
%1

% \border{thickness}{padding}{width}{contents}
\def\border#1#2#3#4{%
  \hbox{\vrule width #1\vbox{\hrule height #1\vskip#2\hbox{\hskip#2
   \vbox{\hsize=#3\relax#4}\hskip#2}\vskip#2\hrule height #1}%
  \vrule width #1}%
}%

%0
% The \z{textarea} macro creates a text area on the card at a relative
% position. It will try the largest text size, and then make it smaller
% until it fits. The rules are the horizontal overfullness must be less
% than \z{hfuzz} and the vertical depth must be less than the specified
% height.

% Box 1 is the box of the area's contents at the current font size. It
% must be a vertical box containing only boxes, kerns, glues, and
% penalties (although there isn't much use to put penalties there). Boxes
% inside this one are allowed to contain anything. The reference point is
% moved such that the height of the box will be zero.

% The \z{iftrial} is set false when it is finally placing the box on the
% page, so that you can add things there such as centering only after it
% is done the trial and is now finally placing the box.
%1

% \textarea{x}{y}{width}{height}{contents}
\def\textarea#1#2#3#4#5{%
  \def\textarea_contents{#5}%
  \let\iftrial=\iftrue
  \setbox1=\vbox{}%
  \fontshrink=0 \loop
    \hsize=#3%
    \setbox1=\vtop{\kern0pt\relax\textarea_contents}%
    \ifdim\dp1<#4\relax
      \overfullness\dimenA{1}
      \ifdim\dimenA<\hfuzz \let\iftrial=\iffalse \fi
    \fi
    \ifnum\fontshrink=\maxfontshrink \let\iftrial=\iffalse \fi
  \iftrial \advance\fontshrink by 1 \repeat
  \setbox1=\vtop to#4{\kern0pt\relax\textarea_contents}%
  \position{#1}{#2}{\box1}%
}%

%0
% It is just here so that \z{iftrial} will match \z{fi}.
%1

\let \iftrial=\iffalse

%0
% The boxes above will place the \z{parskip} glue before the first
% paragraph due to \.{\\kern0pt}. If you do not want this, you can use
% the \z{unparskip} command for helping.
%1

\def\unparskip{\vskip-\parskip}

%0
% Since the boxes in \z{textarea} are not allowed to contain rules, but
% you might want to put rules so we do using \z{boxrule} instead.
%1

\def\boxrule#1{\noskip\vbox{\hrule#1}\noskip}

%0
% You might also want to have two boxes on one line, and have it shrink
% the text horizontally in one or both boxes to make it fit. The baseline
% of the text will be at the specified coordinates.

% It will also check the badness of the created box. You can specify the
% maximum badness which is allowed. If this badness is exceeded, it will
% try again with a smaller size. You can specify 99999 as the maximum
% badness to make it try again only if the box is overfull.

% The font might deal with the magnification by changing only the
% horizontal size so that the letters can be stretched only horizontally.

% You can also set some fonts which do not resize, so that only one half
% of the box will stretch/shrink.
%1

% \pairbox{x}{y}{width}{maxbadness}{ltext}{rtext}
\def\pairbox#1#2#3#4#5#6{%
  \let\iftrial=\iftrue
  \fontshrink=0 \loop
    \hsize=#3
    \setbox2=\hbox{#5}%
    \setbox3=\hbox{#6}%
    \dimenA=\wd2 \dimenB=\wd3
    \advance\dimenA by \dimenB
    \ifdim\dimenA<\hsize \let\iftrial=\iffalse \fi
    \setbox1=\hbox to #3{\unhbox2\hfil\unhbox3}%
    \ifnum\badness>#4 \let\iftrial=\iftrue \fi
    \ifnum\fontshrink=\maxfontshrink \let\iftrial=\iffalse \fi
  \iftrial \advance\fontshrink by 1 \repeat
  \positionbase{#1}{#2}{\box1}%
}%

%0
% Now, you might have text that changes size in a group, relative to the
% current font size. For example, typing \.{\\textsize+2} makes the text
% two sizes larger than normal. This command should be entered inside of a
% group, since it affects the group.
%1

\def\textsize{\begingroup\afterassignment\textsize_\countA}
\def\textsize_{%
  \kern\countA sp\endgroup
  \advance\fontshrink by -\lastkern \unkern
  \ifnum\fontshrink<0 \fontshrink=0 \fi
  \ifnum\fontshrink>\maxfontshrink \fontshrink=\maxfontshrink \fi
}%

% --- Card symbols ---

%0
% A symbol on the card might consist of a symbol from the same or a
% different font, from two fonts on two layers, or from a picture. In any
% case, the symbol must be scaled to the same size as the text.
%1

% \symbol{font}{character}
\def\symbol#1#2{{#1\char#2}}%

% \symbolbg{font}{character}{layer}
\def\symbolbg#1#2#3{%
  \begingroup
  \layer=#3
  \h_left{#1\char#2}%
  \endgroup
  \layer=\layer_selected
}%

%0
% Symbols with pictures (instead of with fonts) are called icons. The top
% left corner of the icon is at the top of the height above the baseline.
% Specials will be inserted in the paragraph at the baseline of the point
% where the icon should appear (and will be discarded if the paragraph is
% discarded). The picture size and box dimensions are adjusted by the
% \z{fontscale}.
%1

% \icon{filename}{size_factor}{width}{height}{depth}
\def\icon#1#2#3#4#5{{%
  \countA=#2 \dimenA=#3 \dimenB=#4 \dimenC=#5
  \calculate_icon_size
  \setbox0=\hbox{\special{\number\dimenB``D\the\countA[#1]`jx}}%
  \wd0=\dimenA
  \ht0=\dimenB
  \dp0=\dimenC
  \box0
}}%

\def\clear_icons{\special{[]si}}

\def\calculate_icon_size#1{%
  \divide\dimenA by 25 \multiply\dimenA by\fontscale \divide\dimenA by 40
  \divide\dimenB by 25 \multiply\dimenB by\fontscale \divide\dimenB by 40
  \divide\dimenC by 25 \multiply\dimenC by\fontscale \divide\dimenC by 40
  \multiply\countA by\fontscale \divide\countA by 1000
}%

\def\paste_icons{\special{li`qx}}

%0
% Another thing with symbols is symbols containing numbers. In this case,
% it might be necessary to resize the digits depending on how many there
% are. They will be centered within the box.

% For example, if using the digits `\.0' to `\.9' then you might set the
% `offset' parameter to 48 and `multiply' to 10. Now character code 25
% will be used to type a `\.5' in a three digit number.
%1

% \numsymbol{font}{width}{offset}{multiply}{text}
\def\numsymbol#1#2#3#4#5{%
  \hbox to #2{%
    \count_tokens\countA={#5}%
    \advance\countA by -1
    \multiply\countA by #4
    \advance\countA by -#3
    \hss % Center
    #1% Select font
    \def\xxx##1{%
      \ifx\relax##1%
        \let\xxx\empty
      \else
        \countB=`##1%
        \advance\countB by\countA
        \char\countB
      \fi
    }\xxx#5\relax
    \hss % Center
  }%
}%

%0
% Finally, there is the set symbols. You have to list the modes and layers
% numbers by spaces. The symbol number is the high nybble and the mode
% number is the low nybble of the character code. Both numbers should be
% in range 0 to 15.
%1

% \setsymbol{font}{symbol_number}{modes}
\def\setsymbol#1#2#3{%
  \begingroup
  \def\setsymbol_{\afterassignment\setsymbol__\countC}%
  \def\setsymbol__{%
    \ifnum\countC=-1
      \let\setsymbol_=\relax
    \else
      \h_left{%
        \layer=\countC
        \advance\countA by \countB
        \char\countA
      }%
    \fi
    \afterassignment\setsymbol_\countB
  }%
  #1%
  \countA=#2
  \multiply\countA by 16
  \afterassignment\setsymbol_\countB #3 -1 -1 0
  \layer=0
  \hbox{\char\countA}
  \endgroup
  \layer=\layer_selected
}%

% --- Image effects ---

%0
% You should redefine these two macros for the directory name, filename
% prefix, and filename suffix (extension) that you want. You should also
% specify the file type in the prefix and/or suffix.
%1

\def\image_filename_prefix{out/}
\def\image_filename_suffix{.png}

%0
% The \z{operator} and \z{group} macros are common in ImageMagick (this
% has nothing to do with groups in \TeX).
%1

\def\operator#1{\special{[#1]`qx}}
\def\group#1{\operator({#1}\operator)}

%0
% This macro is used to write a card image to a file. It is used at the
% end of a page, and is expected to appear in outer vertical mode at the
% top-left corner of a page. The operators and so on that are pasted onto
% the card should be inside the group in the parameter.
%1

\def\card_image#1{%
  \group{%
    \operator{-size \the\px_card_width x\the\px_card_height}%
    \operator{xc:\the\backgroundcolor}%
    {#1}%
    \operator{-write}%
    \operator{\image_filename_prefix\the\pageno\image_filename_suffix}%
  }\operator{+delete}%
}%

%0
% The following macro is used to paste a layer picture onto the card. The
% first parameter is the layer number and the second parameter is the
% color of the text. We also have ones for pasting layers displaced by a
% number of pixels or by a dimension size.
%1

% \paste_layer{layer}{color}
\def\paste_layer#1#2{%
  \paste_layer_with{#1}{#2}{ }%
}%

% \paste_layer_with{layer}{color}{with}
\def\paste_layer_with#1#2#3{%
  \group{%
    \operator{P\the\pageno L#1.pbm}%
    \operator{-transparent white}%
    \operator{-fill #2}%
    \operator{-opaque black}%
    \special{#3}%
  }%
  \operator{-compose src-over}%
  \operator{-composite}%
}%

% \paste_layer_px{layer}{color}{x}{y}
\def\paste_layer_px#1#2#3#4{%
  \paste_layer_with{\enumber{#3}rr\enumber{#4}[-roll]`rx}%
}%

%0
% Note that DVI units are the same as the scaled points which you will get
% when converting a dimension register to a numeric value in \TeX.
%1

% \paste_layer_dim{layer}{color}{x}{y}
\def\paste_layer_dim#1#2#3#4{%
  \dimenA=#3\relax
  \dimenB=#4\relax
  \paste_layer_with{\enumber{#3}C\enumber{#4}C[-roll]`rx}%
}%

%0
% This macro selects which layer to type on. Layer zero means do not
% typeset anything into a picture buffer, but it still must keep track of
% the current position on the page. Positive numbers 1 to 127 typeset onto
% that numbered picture buffer (using OR pen).

% The layer number must be set to the highest layer number used on a card
% before you end the page.
%1

\def\layer{\afterassignment\layer_\layer_selected}
\def\layer_{\special{\the\layer_selected sL}}

% --- Meta page ---

\def\metapage#1#2#3{
  \pageno=0 \resolution=#1 \px_card_width=#2 \px_card_height=#3

%0
% This makes the \.q register which adds a operator or parameter to the
% end of the ImageMagick list.
%1

  \special{[lQdZ0[][ ]i+r+sQ]sq}

%0
% This part is used to make optional parameters to ImageMagick with
% positive and negative coordinates. Such parameters might be \.{-roll}
% and so on.
%1

  \special{[d[0r-[-]][[+]]dixrB+]sn}
  \special{[`qx`nxr`nx+`qx]sr}

%0
% There is \.y like \.q but for icon list. And \.j then calls it.
%1

  \special{[lidZ0[][ ]i+r+si]sy}
  \special{[% Parameters: ( height size_factor filename -- )
    [(]`yx%
    `yx% Filename
    [-scale]`yx% Scale (resize)
    d10\%B[.]r+% One tenths of a percent
    r10/Br+% Units of a percent
    [\%]+`yx% Percentage sign
    [)]`yx%
    lYrC-lX[-geometry]`yx`nxr`nx+`yx% Position of icon
    [-compose src-over -composite +geometry]`yx% Paste and reset position
  ]sj}%

%0
% And now the end of the meta page.
%1

  \endpage
}

% --- End of file ---

\dump
